//parse url params
var urlParams = {};
(function() {
	var e, 
	a = /\+/g,  // Regex for replacing addition symbol with a space
	r = /([^&=]+)=?([^&]*)/g, 
	d = function(s) {
		return decodeURIComponent(s.replace(a, " "));
	}, 
	q = window.location.search.substring(1);
	
	while (e = r.exec(q))
		urlParams[d(e[1])] = d(e[2]);
})();

//extend zepto fullScreen
$.fn.fullScreen = function(){
		//get window width and height
		
		var window_width = document.documentElement.clientWidth,
			window_height = document.documentElement.clientHeight;
			
			/*
		var window_width = window.screen.availWidth,
			window_height = window.screen.availHeight;
		*/
		this.width(window_width);
		this.height(window_height);

		return this;;
};
$.fn.fillRatio = function(_width,_height){
	//get window width and height
	var window_width = document.documentElement.clientWidth,
		window_height = document.documentElement.clientHeight;
		
	//inti ratio
	var ratio = _width/_height;
	var window_ratio = window_width / window_height;

	//calc scale
	if( window_ratio < ratio ){
		swp_width = window_width;
		swp_height = Math.floor( window_width / ratio );
		swp_top = Math.floor( (window_height - swp_height) / 2 );
		
		$(this).width(swp_width);
		$(this).height(swp_height);
		$(this).css("top", swp_top);
	} else if( window_ratio >= ratio ){
		$(this).height(window_height);
		$(this).width(Math.floor( window_height * ratio ));
	}
	
	return this;
};
/** animate css 扩展方法，自动解除动画类名以便于再次执行
* 用法：$('#yourElement').animateCss('bounce');
*/
$.extend($.fn,{
	/* 利用AnimationEnd事件监听会产生连续动画问题 */
    animateCss: function (animationName) {
        var animationEnd = 'webkitAnimationEnd mozAnimationEnd MSAnimationEnd oanimationend animationend';
        $(this).addClass('animated ' + animationName).one(animationEnd, function() {
            $(this).removeClass('animated ' + animationName);
        });
    },
	/* animateCSS
	* @params animationName string 要执行的动画CSS类名
	* @params animationDuration integer 动画执行时间
	* @params callbackFunction function 动画执行完毕后的回调
	* @return 当前DOM元素
	*/
	animateCSS:function(animationName,animationDuration,callbackFunction){
		var $this = $(this);
		$this.addClass('animated ' + animationName);
		if(callbackFunction != undefined && animationDuration != undefined){
			setTimeout(function(){
				//console.log($this.removeClass(animationName));//不能直接删除添加的类，否则效果立即结束
				callbackFunction();
			},animationDuration);
		}
		return this;
	},
	fadeIn:function(animateDuration,fn){
		this.addClass('animated fadeIn');
		//setTimeout(fn,animateDuration);
		return this;
	},
	fadeOut:function(){
		this.addClass('animated fadeOut');
		return this;
	},
	slideInDown:function(){
		this.addClass('animated slideInDown');
		return this;
	},
	slideOutDown:function(){
		this.addClass('animated slideOutDown');
		return this;
	},
	slideInUp:function(){
		this.addClass('animated slideInUp');
		return this;
	},
	slideOutUp:function(){
		this.addClass('animated slideOutUp');
		return this;
	},
	hidd:function(){
		this.addClass('hidden');
		return this;
	},
	visi:function(){
		this.removeClass('hidden');
		return this;
	},
	clearAnimate:function(){
		var allNames = 'bounce flash pulse rubberBand shake headShake swing tada wobble jello bounceIn bounceInDown bounceInLeft bounceInRight bounceInUp bounceOut bounceOutDown bounceOutLeft bounceOutRight bounceOutUp fadeIn fadeInDown fadeInDownBig fadeInLeft fadeInLeftBig fadeInRight fadeInRightBig fadeInUp fadeInUpBig fadeOut fadeOutDown fadeOutDownBig fadeOutLeft fadeOutLeftBig fadeOutRight fadeOutRightBig fadeOutUp fadeOutUpBig flipInX flipInY flipOutX flipOutY lightSpeedIn lightSpeedOut rotateIn rotateInDownLeft rotateInDownRight rotateInUpLeft rotateInUpRight rotateOut rotateOutDownLeft rotateOutDownRight rotateOutUpLeft rotateOutUpRight hinge rollIn rollOut zoomIn zoomInDown zoomInLeft zoomInRight zoomInUp zoomOut zoomOutDown zoomOutLeft zoomOutRight zoomOutUp slideInDown slideInLeft slideInRight slideInUp slideOutDown slideOutLeft slideOutRight slideOutUp ';
		this.removeClass('animated ' + allNames);
		return this;
	},
	delay:function(time,fn){
		setTimeout(fn,time);
		return this;
	},
	prefixedEvent: function(type,callback){
		var pfx = ["webkit", "moz", "MS", "o", ""];
		for (var p = 0; p < pfx.length; p++) {
			if (!pfx[p]) type = type.toLowerCase();
			this.addEventListener(pfx[p]+type, callback, false);
		}
		return this;
	}

	
});

$.fn.launchFullScreen = function(){
	if(this.requestFullscreen) {
    this.requestFullscreen();
  } else if(this.mozRequestFullScreen) {
    this.mozRequestFullScreen();
  } else if(this.webkitRequestFullscreen) {
    this.webkitRequestFullscreen();
  } else if(this.msRequestFullscreen) {
    this.msRequestFullscreen();
  }
}


function launchFullscreen(element) {
	  if(element.requestFullscreen) {
		element.requestFullscreen();
	  } else if(element.mozRequestFullScreen) {
		element.mozRequestFullScreen();
	  } else if(element.msRequestFullscreen){
		element.msRequestFullscreen();
	  } else if(element.webkitRequestFullscreen) {
		element.webkitRequestFullScreen();
	  }
}
function launchFullScreen(element) {
	  if(element.requestFullscreen) {
		element.requestFullscreen();
	  } else if(element.mozRequestFullScreen) {
		element.mozRequestFullScreen();
	  } else if(element.msRequestFullscreen){
		element.msRequestFullscreen();
	  } else if(element.webkitRequestFullscreen) {
		element.webkitRequestFullScreen();
	  }
}
function exitFullscreen() {
  if (document.exitFullscreen) {
	document.exitFullscreen();
  } else if (document.msExitFullscreen) {
	document.msExitFullscreen();
  } else if (document.mozCancelFullScreen) {
	document.mozCancelFullScreen();
  } else if (document.webkitExitFullscreen) {
	document.webkitExitFullscreen();
  }
}
function exitFullScreen() {
  if (document.exitFullscreen) {
	document.exitFullscreen();
  } else if (document.msExitFullscreen) {
	document.msExitFullscreen();
  } else if (document.mozCancelFullScreen) {
	document.mozCancelFullScreen();
  } else if (document.webkitExitFullscreen) {
	document.webkitExitFullscreen();
  }
}

/* Event Util */
var EventUtil = {
    addHandler: function (element, type, handler) {
        if (element.addEventListener) {
            element.addEventListener(type, handler, false);
        } else if (element.attachEvent) {
            element.attachEvent("on" + type, handler);
        } else {
            element["on" + type] = handler;
        }
    },
    removeHandler: function (element, type, handler) {
        if (element.removeEventListener) {
            element.removeEventListener(type, handler, false);
        } else if (element.detachEvent) {
            element.detachEvent("on" + type, handler);
        } else {
            element["on" + type] = null;
        }
    },
    getEvent: function (event) {
        return event ? event : window.event;
    },
    getTarget: function (event) {
        return event.target || event.srcElement;
    }
};;


/* 绑定事件前缀 */
var pfx = ["webkit", "moz", "MS", "o", ""];
function PrefixedEvent(element, type, callback) {
	for (var p = 0; p < pfx.length; p++) {
		if (!pfx[p]) type = type.toLowerCase();
		element.addEventListener(pfx[p]+type, callback, false);
	}
}